//+------------------------------------------------------------------+
//|                                                  Cheburashka.mq4 |
//|                                         Copyright  2008, Kirill |
//|                                          StockProgrammer@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Kirill"
#property link      "StockProgrammer@mail.ru"


//v21.1 = v20.1 + TimeTradeTrigger

//v20.1 = v19.1 + UsePercentBalance
/*
 UsePercentBalance = false,    
Lots_1
Lots_2
...
Lots_10
  .
  UsePercentBalance = true,     . .
 Lots_1 = 0.25 - ,    25%  . .
*/

//v18.0 = v16.0 + "Point_=Point;" +:
/*
 2-    AUDUSD     ...        .
:
1-  stop loss - 10
2-  stop loss - 20
  -30 ...     3-           , .  +30 ,      take profit ...     3-     ...
    ???
*/

/*
BuyStopPrice -    Buy Stop ,     . 
  Stop Loss & Take Profit .Order Level-   Stop Loss & 
Take Profit.Lots_1,Lots_2   Lots_10 (   ,  ,
  ).  Buy Stop    Sell Stop c    
  Stop Loss  .   ,   .  
   Stop Loss,         
     ,        
 ,   Take Profit,   10 .

TimeFrame = 60
Magic_N = 444,    ,     ,    , 
.. 444, 445, 446, 447, ..
Show_Alerts = true,             . 
 false,        .
Send_Email = false.        e-mail     
,   true.
   ,      ,      
    e-mail.
InfoOn = true.       .
InfoColor = Yellow.    

      .         : 
The system is ready to input BuyStopPrice -     BuyStopPrice 
 
  ,    BuyStopPrice   . 
     0.     
"The system is ready to input BuyStopPrice"   .

            .
 ,     ,      BuyStopPrice  0. 
          . 
*/

extern int     Magic          =  1032;
extern bool    Check_5Digits  =  false;
extern bool    LOAD_DATA      =  false;
extern double  BuyStopPrice   =  0.0;
extern int     Delta          =  20;
extern int     TakeProfit     =  200;
extern int     StopLoss       =  100;
extern bool    TimeTradeTrigger = false;
extern int     TimeTradeHour  =  12;
extern bool    UseTrailOnly1  =  false;
extern int     Trail1         =  50;
extern bool    UseZeroLossStrategy = false;
extern int     ZeroLossT      =  3;       //     
extern bool    UsePercentBalance = false;
extern double  Lots_1	=	0.1	;
extern double  Lots_2	=	0.15	;
extern double  Lots_3	=	0.23	;
extern double  Lots_4	=	0.35	;
extern double  Lots_5	=	0.53	;
extern double  Lots_6	=	0.8	;
extern double  Lots_7	=	1.20	;
extern double  Lots_8	=	1.80	;
extern double  Lots_9	=	2.70	;
extern double  Lots_10	=	4.05	;
extern double  Lots_11	=	6.08	;
extern double  Lots_12	=	9.12	;
extern double  Lots_13	=	13.68	;
extern double  Lots_14	=	20.52	;
extern double  Lots_15	=	30.78	;
extern double  Lots_16	=	46.17	;
extern double  Lots_17	=	69.26	;
extern double  Lots_18	=	103.89	;
extern double  Lots_19	=	155.84	;
extern double  Lots_20	=	233.76	;
extern double  Lots_21	=	350.64	;
extern double  Lots_22	=	525.96	;
extern double  Lots_23	=	788.94	;

extern bool    EnableMonthlyProfit     = true;
extern bool    RestartProfitCount      = false;
extern int     MaxEquity               = 120;     //%    (   )
extern int     MinEquity               = 0;      //%    (   )

int            slip           =  3;

bool           flag           =  1;    //1 = restart flag
double         BSP            =  0.0;  //last used BuyStopPrice

int            t1, t2;                 //Temporary ticket holders for the first two orders of current series
int            T;                      //Current pending order array index (0, 1, 2, 3, 4, 5, 6, 7, 8, 9)
int            tArray[23];             //Holds current series ticket numbers
   
double         LotsArray[23];          //Convenience array. Holds input parameters
 
int Ticket[1000];

int critical = 0;

double Point_;

double LotMin_;
double LotMax_;
double LotStep_;

string         CommentArray[7];

int init()
{
   CommentArray[0] = "MVStandard v2";

   Point_ = Point;

   if(Check_5Digits == true && (Digits == 3 || Digits == 5))
   {
      Alert("Digits=", Digits, " Broker quotes given in 5-digit mode. \"Point\" will be multiplied by 10");
      Point_ = 10*Point;
   }
   
   LotMin_  = MarketInfo(Symbol(), MODE_MINLOT);
   LotMax_  = MarketInfo(Symbol(), MODE_MAXLOT);
   LotStep_ = MarketInfo(Symbol(), MODE_LOTSTEP);


   if(LOAD_DATA == false)
   {
      LotsArray[0] = Lots_1;
      LotsArray[1] = Lots_2;
      LotsArray[2] = Lots_3;
      LotsArray[3] = Lots_4;
      LotsArray[4] = Lots_5;
      LotsArray[5] = Lots_6;
      LotsArray[6] = Lots_7;
      LotsArray[7] = Lots_8;
      LotsArray[8] = Lots_9;
      LotsArray[9] = Lots_10;
      LotsArray[10] = Lots_11;
      LotsArray[11] = Lots_12;
      LotsArray[12] = Lots_13;
      LotsArray[13] = Lots_14;
      LotsArray[14] = Lots_15;
      LotsArray[15] = Lots_16;
      LotsArray[16] = Lots_17;
      LotsArray[17] = Lots_18;
      LotsArray[18] = Lots_19;
      LotsArray[19] = Lots_20;
      LotsArray[20] = Lots_21;
      LotsArray[21] = Lots_22;
      LotsArray[22] = Lots_23;
      
   }
   else
      LOAD();
   return(0);
}

int deinit()
{
    Alert("Deinit. Saving data to file \"Cheburashka_" + DoubleToStr(Magic, 0) + ".csv\". Pending orders WILL NOT be deleted.");
    SAVE();
    if(critical == 1)
    {
      GlobalVariableSet("SEMAPHORE_CHEB_1", 0.0);    // ,   ,      
      GlobalVariableSet("SEMAPHORE_CHEB_2", 0.0);    // ,   ,      
    }  
    return(0);
}


int start()
{
   bool AllowTrades = true;
   
   if(EnableMonthlyProfit)       //     
      if(MonthlyProfit() == 0)      //      
      {
         AllowTrades = false;                    // 
         CommentArray[1] = "";
      }
      
   if(AllowTrades == true)
   {
      if(flag == 1 && TimeTradeTrigger == true && Hour() != TimeTradeHour) return(0);  //       v21.1
      if(flag == 1 && BSP == BuyStopPrice) BuyStopPrice = Ask + Delta*Point_;
      //no else !
      //WORK BLOCK
      { 
         if(T==0)
            CommentArray[1] = "System is working. No active lot yet.";
         else
            CommentArray[1] = "System is working. Active lot: " + DoubleToStr(LotsArray[T-1],2);
        
         if(flag==1) //  
         {  
            Alert(Ask, " ", Delta, " ", DoubleToStr(Point_,5), " ", BuyStopPrice);
            t1 = OrderSend(Symbol(), OP_SELLLIMIT, LotPercent(LotsArray[0]), BuyStopPrice, slip, BuyStopPrice + TakeProfit*Point_, BuyStopPrice - StopLoss*Point_, NULL, Magic);
            if(t1 < 0)  {restart(1); return (0);}
         
            t2 = OrderSend(Symbol(), OP_BUYLIMIT, LotPercent(LotsArray[0]), BuyStopPrice - StopLoss*Point_, slip, BuyStopPrice - StopLoss*Point_ - TakeProfit*Point_, BuyStopPrice, NULL, Magic);
            if(t2 < 0)  {restart(2); return (0);}
         
            flag = 0; BSP = BuyStopPrice;
         
            SAVE();
         }
      
         else
         {
            if(T == 0)
            {
               OrderSelect(t2, SELECT_BY_TICKET);
               if(OrderType() == OP_BUY)
               {
                  OrderDelete(t1);
                  tArray[0] = t2;
                  tArray[1] = OrderSend(Symbol(), OP_SELLLIMIT, LotPercent(LotsArray[1]), BuyStopPrice, slip, BuyStopPrice + TakeProfit*Point_, BuyStopPrice - StopLoss*Point_, NULL, Magic);
                  T = 1;
                  if(tArray[1] < 0)  {restart(0); return (0);}
               
                  SAVE();
                  return (0);
               }   
         
               OrderSelect(t1, SELECT_BY_TICKET);      
               if(OrderType() == OP_SELL)
               {
                  OrderDelete(t2);
                  tArray[0] = t1;
                  tArray[1] = OrderSend(Symbol(), OP_BUYLIMIT, LotPercent(LotsArray[1]), BuyStopPrice - StopLoss*Point_, slip, BuyStopPrice - StopLoss*Point_ - TakeProfit*Point_, BuyStopPrice, NULL, Magic);
                  T = 1;
                  if(tArray[1] < 0)  {restart(0); return (0);}
               
                  SAVE();
                  return(0);            
               }
            
               return (0); //none of the first two orders have been opened   
            }
            else
            {
               if(!OrderSelect(tArray[T-1], SELECT_BY_TICKET)) Alert("???");
               if(OrderCloseTime()!=0)
               {           
                  if(OrderProfit() < 0) //Profit or Trailing-stop exit
                  {
                     //the pending order will be deleted by restart() function
                     restart(190);
                     return (0);               
                  }

                  else  //profit < 0
                  {
                     if(T == 22)  //highest order in series (order number 10) will have index = 9
                        {restart(10);  return (0);}
               
                     else
                     {
                        int cmd;
                  
                        OrderSelect(tArray[T-1], SELECT_BY_TICKET);
                  
                        if(OrderType() == OP_BUY)
                           cmd = OP_BUYLIMIT;
                        else
                           cmd = OP_SELLLIMIT;
                     
                        tArray[T+1] = OrderSend(Symbol(), cmd, LotPercent(LotsArray[T+1]), OrderOpenPrice(), slip, OrderStopLoss(), OrderTakeProfit(), NULL, Magic);
                        T++;
                        if(tArray[T] < 0)  {restart(0); return (0);}
                  
                        SAVE();
                        return (0);
                     }
                  }       
               }
            }
         }
      }  
   
      if(UseTrailOnly1 == true) TrailingStop1();
      if(UseZeroLossStrategy == true) ZeroLossStrategy();      
   
   }
   
   PrintComment();
   
   return(0);
}


void restart(int code)           //preparing everything for new series
{
   int i;
   
   switch(code)
   {
      case 1:     Alert("Could not open first BUYSTOP order. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 2:     Alert("Could not open first SELLSTOP order. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 0:     Alert("Could not open pending order number ", T, " in current series. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 190:   Alert("Profit reached or out on trailing stop! Restarting...");
                  break;         
      case 200:   Alert("ZeroLossStrategy exit! Restarting...");
                  break; 
      case 10:    Alert("10 orders done. Series finished. Restarting...");
                  break;
      case -1:    Alert("Last order wasn\'t closed buy stoploss or takeprofit. Restarting...");
                  break;
      case -2:    Alert("Deinit. Deleting all pending orders.");
                  break;
      case -50:   Alert("Unsuccessfull LOAD. Restarting with default parameters.");
                  break;                                     
   }

   for(i=0; i<23; i++)           //deleting all pending orders
   {
      OrderSelect(tArray[i], SELECT_BY_TICKET);
      if(OrderType() == OP_SELLLIMIT || OrderType() == OP_BUYLIMIT)
         OrderDelete(tArray[i]);  
   }
   
   OrderSelect(t1, SELECT_BY_TICKET);
   if(OrderType() == OP_SELLLIMIT)
      OrderDelete(t1);    
       
   OrderSelect(t2, SELECT_BY_TICKET);
   if(OrderType() == OP_BUYLIMIT)
      OrderDelete(t2);           
   
   for(i=0; i<23; i++)           //preparing tArray[]
      tArray[i] = 0;

   T=0;
   t1=0;
   t2=0;
   
   
   BSP   = BuyStopPrice;         //needed restart flag
   flag  = 1;                    //main restart flag
   
   return (0);   
}

void TrailingStop1()
{
   if(T==1) //.. 0- 
   {
      OrderSelect(tArray[0], SELECT_BY_TICKET);
      
      if(OrderType() == OP_BUY)
         if(Close[1]-OrderOpenPrice()>Point_*Trail1)   
            if(Close[1] - OrderStopLoss() > Trail1*Point_)
               OrderModify(OrderTicket(), 0, Close[1] - Trail1*Point_, OrderTakeProfit(), 0); 
   
      if(OrderType() == OP_SELL)
         if(OrderOpenPrice()-Close[1]>Point_*Trail1)
            if(OrderStopLoss() - Close[1] > Trail1*Point_)
               OrderModify(OrderTicket(), 0, Close[1] + Trail1*Point_, OrderTakeProfit(), 0);        
   }
}

void ZeroLossStrategy()
{
   double summ_profit = 0.0;
   bool res = false;
   
   if(T>ZeroLossT) //..   #ZeroLossT  
   {
      for(int i=0; i<T; i++)
      {
         OrderSelect(tArray[i], SELECT_BY_TICKET);
         summ_profit += OrderProfit();
      }
      
      if(summ_profit >= 0.0)
      {
         OrderSelect(tArray[T-1], SELECT_BY_TICKET);  //  
         if(OrderType() == OP_BUY)
         {
            res = OrderClose(OrderTicket(), OrderLots(), Bid, slip, White);
         }
         else if(OrderType() == OP_SELL)
         {
            res = OrderClose(OrderTicket(), OrderLots(), Ask, slip, White);
         }
         
         if(res == true)
            restart(200);         
      }   
   }
}

void SAVE()
{
   int handle = FileOpen("Cheburashka_" + DoubleToStr(Magic, 0) + ".csv", FILE_CSV | FILE_WRITE);
   if(handle<0) Alert("File Open Error: ", GetLastError());  
   
   int res    = FileWrite( handle, BuyStopPrice, TakeProfit, StopLoss, TimeTradeTrigger, TimeTradeHour, Check_5Digits, UseTrailOnly1, Trail1, UseZeroLossStrategy, ZeroLossT, UsePercentBalance, flag, BSP, t1, t2, T, EnableMonthlyProfit, RestartProfitCount, MinEquity, MaxEquity, tArray[0], tArray[1], tArray[2], tArray[3], tArray[4], tArray[5], tArray[6], tArray[7], tArray[8], tArray[9], LotsArray[0], LotsArray[1], LotsArray[2], LotsArray[3], LotsArray[4], LotsArray[5], LotsArray[6], LotsArray[7], LotsArray[8], LotsArray[9] );
   if(res < 0)  Alert("File Write Attempt Failed. Error: ", GetLastError());   

   Print("Saved Parameters: ", BuyStopPrice, " ", TakeProfit, " ", StopLoss, " ", TimeTradeTrigger, " ", TimeTradeHour, " ", Check_5Digits, " ", UseTrailOnly1, " ", Trail1, " ", UseZeroLossStrategy, " ", ZeroLossT, " ", UsePercentBalance, " ", flag, " ", BSP, " ", t1, " ", t2, " ", T, " ", EnableMonthlyProfit, " ", RestartProfitCount, " ", MinEquity, " ", MaxEquity, " (continued)"); Print("(continued) ", tArray[0], " ", tArray[1], " ", tArray[2], " ", tArray[3], " ", tArray[4], " ", tArray[5], " ", tArray[6], " ", tArray[7], " ", tArray[8], " ", tArray[9], " ", LotsArray[0], " ", LotsArray[1], " ", LotsArray[2], " ", LotsArray[3], " ", LotsArray[4], " ", LotsArray[5], " ", LotsArray[6], " ", LotsArray[7], " ", LotsArray[8], " ", LotsArray[9]  );
   
   FileClose(handle);   
}

void LOAD()
{
   int i, res;
   
   int handle = FileOpen("Cheburashka_" + DoubleToStr(Magic, 0) + ".csv", FILE_CSV | FILE_READ);
   if(handle<0) Alert("File Open Error: ", GetLastError());    
   
   BuyStopPrice   =  FileReadNumber(handle);
   TakeProfit     =  FileReadNumber(handle);
   StopLoss       =  FileReadNumber(handle);
   TimeTradeTrigger  = FileReadNumber(handle);
   TimeTradeHour     = FileReadNumber(handle);
   Check_5Digits  =  FileReadNumber(handle);
   UseTrailOnly1  =  FileReadNumber(handle);
   Trail1         =  FileReadNumber(handle);
   UseZeroLossStrategy =  FileReadNumber(handle);
   ZeroLossT           =  FileReadNumber(handle);
   UsePercentBalance   =  FileReadNumber(handle);
   flag           =  FileReadNumber(handle);
   BSP            =  FileReadNumber(handle);
   t1             =  FileReadNumber(handle);
   t2             =  FileReadNumber(handle);
   T              =  FileReadNumber(handle);
   EnableMonthlyProfit     =  FileReadNumber(handle);
   RestartProfitCount      =  FileReadNumber(handle);
   MinEquity               =  FileReadNumber(handle);
   MaxEquity               =  FileReadNumber(handle);   
   for(i=0; i<10; i++)
      tArray[i] = FileReadNumber(handle);
   for(i=0; i<10; i++)
      LotsArray[i] = FileReadNumber(handle);
   
   FileClose(handle);   
   
   Alert("Loaded Parameters: ", BuyStopPrice, " ", TakeProfit, " ", StopLoss, " ", TimeTradeTrigger, " ", TimeTradeHour, " ", Check_5Digits, " ", UseTrailOnly1, " ", Trail1, " ", UseZeroLossStrategy, " ", ZeroLossT, " ", UsePercentBalance, " ", flag, " ", BSP, " ", t1, " ", t2, " ", T, " ", EnableMonthlyProfit, " ", RestartProfitCount, " ", MinEquity, " ", MaxEquity, " (continued)"); Print("(continued) ", tArray[0], " ", tArray[1], " ", tArray[2], " ", tArray[3], " ", tArray[4], " ", tArray[5], " ", tArray[6], " ", tArray[7], " ", tArray[8], " ", tArray[9], " ", LotsArray[0], " ", LotsArray[1], " ", LotsArray[2], " ", LotsArray[3], " ", LotsArray[4], " ", LotsArray[5], " ", LotsArray[6], " ", LotsArray[7], " ", LotsArray[8], " ", LotsArray[9]  );
   
   res = ExamineParameters();
   
   if(res == 2)
      restart(-50);
   else if(res == 1)
      Alert("Load successfull. Continuing work.");  
}

int ExamineParameters()
{
//:   ,     ,         
//    , ..    ,  ,    . 
//( . . ,          )
   if(T==0)
   {
      OrderSelect(t1, SELECT_BY_POS);
      if(OrderType() == OP_BUY)
         if(OrderCloseTime() != 0 || ( Bid - OrderStopLoss() < (MarketInfo(Symbol(), MODE_STOPLEVEL)+1)*Point_ ) )
            {Alert("1");      return(2); }
      OrderSelect(t2, SELECT_BY_POS);
      if(OrderType() == OP_SELL)
         if(OrderCloseTime() != 0 || ( OrderStopLoss() - Ask < (MarketInfo(Symbol(), MODE_STOPLEVEL)+1)*Point_ ) )
            {Alert("2");      return(2); }
   }
   
   else
   {
      OrderSelect(tArray[T], SELECT_BY_POS);
      if(OrderType() == OP_BUY)
         if(OrderCloseTime() != 0 || ( Bid - OrderStopLoss() < (MarketInfo(Symbol(), MODE_STOPLEVEL)+1)*Point_ ) )
            {Alert("4");      return(2); }
      if(OrderType() == OP_SELL)
         if(OrderCloseTime() != 0 || ( OrderStopLoss() - Ask < (MarketInfo(Symbol(), MODE_STOPLEVEL)+1)*Point_ ) )
            {Alert("5");      return(2); }
   }
   
   return(1);
}

//-----------------------------------------------  ------------------------------------------------
void SemaphoreTake(string SEM)
{ 
   if(GlobalVariableCheck(SEM) == false)
      GlobalVariableSet(SEM, 0);
  
   while(1==1)
   {
      if(GlobalVariableSetOnCondition(SEM, 1.0, 0.0))         // 
      {
         critical = 1;
         Print("SEMAPHORE \"", SEM, "\" TAKEN. CURRENT VALUE: ", GlobalVariableGet(SEM));
         break;      //    
      }
      else
      {
         Print("ATTEMPT TO CAPTURE SEMAPHORE \"", SEM, "\" FAILED. SEMAPHORE BUSY. WAITING 0.1 SEC. CURRENT VALUE: ", GlobalVariableGet(SEM));
         Sleep(100);
      }
   }
} 

void SemaphoreReturn(string SEM)
{
   GlobalVariableSet(SEM, 0.0);
   Print("SEMAPHORE \"", SEM, "\" RETURNED. CURRENT VALUE: ", GlobalVariableGet(SEM));
   critical = 0;
}

//-----------------------------------------------PROFIT/LOSS CONTROL------------------------------------------------
//gAllowed, gMonth, gStartingEquity
int MonthlyProfit()
{
   int ret = 1;
   
   SemaphoreTake("SEMAPHORE_CHEB_2");
   
      if(GlobalVariableCheck("gAllowed") == false)          //   
      {
         GlobalVariableSet("gAllowed", 1);
         GlobalVariableSet("gMonth", Month());
         GlobalVariableSet("gStartingEquity", AccountEquity());
      }
   
      double _Allowed, _Month, _StartingEquity;
      _Month            = GlobalVariableGet("gMonth");
   
      if(RestartProfitCount == true || Month() != _Month)   //        
      {
         GlobalVariableSet("gAllowed", 1);
         GlobalVariableSet("gMonth", Month());
         GlobalVariableSet("gStartingEquity", AccountEquity());
         RestartProfitCount = false;
      }

      _Month            = GlobalVariableGet("gMonth");
      _Allowed          = GlobalVariableGet("gAllowed");
      _StartingEquity   = GlobalVariableGet("gStartingEquity");
   
      if(_Allowed < 0.0)   ret = 0;
   
   //-------------------------------------------------------
      else
      {
         double EquityNow = AccountEquity();
   
         CommentArray[2] = "Month Starting Equity: " + DoubleToStr(_StartingEquity, 2);
         CommentArray[3] = "Current Equity:           " + DoubleToStr(EquityNow, 2);
   
         if( NormalizeDouble(EquityNow, 2) < NormalizeDouble((MinEquity/100.0)*_StartingEquity,2) )
         {
            Alert("Current Equity Is < ", MinEquity, "% * Starting Equity Of This Month.\nTrades Stopped.");
            CloseAllOrders();
            GlobalVariableSet("gAllowed", -1);                 //    
            CommentArray[4] = "Trades Stopped At: " + TimeToStr(TimeCurrent()) + "\n" +
                              "Reason: " + DoubleToStr(EquityNow, 2) + " < " + DoubleToStr(MinEquity/100.0, 2) + "*" + DoubleToStr(_StartingEquity, 2) + "\n" +
                              "Trades Will Recommence At The Beggining Of Next Month";
            ret = 0;
         }
      
         if( NormalizeDouble(EquityNow, 2) > NormalizeDouble((MaxEquity/100.0)*_StartingEquity,2) )
         {
            Alert("Current Equity Is > ", MaxEquity, "% * Starting Equity Of This Month.\nTrades Stopped.");
            CloseAllOrders();
            GlobalVariableSet("gAllowed", -1);                 //    
            CommentArray[4] = "Trades Stopped At: " + TimeToStr(TimeCurrent()) + "\n" +
                              "Reason: " + DoubleToStr(EquityNow, 2) + " > " + DoubleToStr(MaxEquity/100.0, 2) + "*" + DoubleToStr(_StartingEquity, 2) + "\n" +
                              "Trades Will Recommence At The Beggining Of Next Month";
            ret = 0;
         }
   
         if(ret!=0)
         {
            CommentArray[4] = "Min Equity:  " + DoubleToStr(MinEquity/100.0, 2) + "*" + DoubleToStr(_StartingEquity, 2) + " = " + DoubleToStr((MinEquity/100.0)*_StartingEquity,2) + "\n" +
                              "Max Equity: " + DoubleToStr(MaxEquity/100.0, 2) + "*" + DoubleToStr(_StartingEquity, 2) + " = " + DoubleToStr((MaxEquity/100.0)*_StartingEquity,2) + "\n" +
                              "Equity OK:  "  + DoubleToStr((MinEquity/100.0)*_StartingEquity,2) + " < " + DoubleToStr(EquityNow, 2) + " < " + DoubleToStr((MaxEquity/100.0)*_StartingEquity,2);
         }                     
      }
      
   SemaphoreReturn("SEMAPHORE_CHEB_2"); 

   return(ret);

}  

void CloseAllOrders()
{
   int res, i, total = OrdersTotal();
   
   Alert("!!! CLOSING ALL ORDERS !!!");
   Print("! Closing all orders performed by robot: Magic = ", Magic, " Symbol = ", Symbol());
   
   total = CreateTicketArrayAll(OP_BUY);   
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Closing OP_BUY Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), slip, White);         
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderClose Error: ", GetLastError());
   }
   
   total = CreateTicketArrayAll(OP_SELL);   
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Closing OP_SELL Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_ASK), slip, White);         
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderClose Error: ", GetLastError());
   }

   total = CreateTicketArrayAll(OP_SELLLIMIT); 
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_BUYSTOP Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }

   total = CreateTicketArrayAll(OP_BUYLIMIT);
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_SELLSTOP Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }

   total = CreateTicketArrayAll(OP_BUYLIMIT); 
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_BUYLIMIT Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }
   
   total = CreateTicketArrayAll(OP_SELLLIMIT); 
   for(i=0; i<total; i++)
   {
      OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_SELLLIMIT Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }      
}

int CreateTicketArrayAll(int dir)
{
   int total=OrdersTotal(), i, c=0; if (total<=0) return (0);
	for(i=0;i<total;i++) { OrderSelect(i, SELECT_BY_POS); if (OrderType()==dir) { Ticket[c] = OrderTicket(); c++; } }
	return (c);
}

//-----------------------------------------------COMMENT------------------------------------------------
void PrintComment()
{
   Comment(CommentArray[0], "\n",
           "Current Situation: ", CommentArray[1], "\n",
           "-------------------------------\n",
           CommentArray[2], "\n",
           CommentArray[3], "\n",
           CommentArray[4], "\n",
           CommentArray[5], "\n",
           CommentArray[6], "\n");
}

//-----------------------------------------------LotPercent------------------------------------------------
double LotPercent(double X)
{
   double vol = 0.0; 
   
   if(UsePercentBalance == false) vol = X;      //    
   
   else                                         //    
   {  
      vol = AccountBalance()*X;
      vol = MathRound(vol / LotStep_)  * LotStep_;
      if(vol == 0) Alert("!!! Not enough funds to open order !!!");
      else if(NormalizeDouble(vol-LotMin_,2) < 0) {Print("!!! Rounding lot up to LotMin !!!"); vol = LotMin_;}
      else if(NormalizeDouble(vol-LotMax_,2) > 0) {Print("!!! Rounding lot down to LotMax !!!"); vol = LotMax_;}
   }

   return(vol);
}